pragma Ada_95;
pragma Source_File_Name (ada_main, Spec_File_Name => "b~templatespp.ads");
pragma Source_File_Name (ada_main, Body_File_Name => "b~templatespp.adb");

with System.Restrictions;
with Ada.Exceptions;

package body ada_main is
   pragma Warnings (Off);

   E108 : Short_Integer; pragma Import (Ada, E108, "system__os_lib_E");
   E013 : Short_Integer; pragma Import (Ada, E013, "system__soft_links_E");
   E019 : Short_Integer; pragma Import (Ada, E019, "system__exception_table_E");
   E139 : Short_Integer; pragma Import (Ada, E139, "ada__containers_E");
   E094 : Short_Integer; pragma Import (Ada, E094, "ada__io_exceptions_E");
   E047 : Short_Integer; pragma Import (Ada, E047, "ada__strings_E");
   E053 : Short_Integer; pragma Import (Ada, E053, "ada__strings__maps_E");
   E121 : Short_Integer; pragma Import (Ada, E121, "ada__strings__maps__constants_E");
   E060 : Short_Integer; pragma Import (Ada, E060, "ada__tags_E");
   E083 : Short_Integer; pragma Import (Ada, E083, "ada__streams_E");
   E103 : Short_Integer; pragma Import (Ada, E103, "interfaces__c_E");
   E105 : Short_Integer; pragma Import (Ada, E105, "interfaces__c__strings_E");
   E025 : Short_Integer; pragma Import (Ada, E025, "system__exceptions_E");
   E085 : Short_Integer; pragma Import (Ada, E085, "system__finalization_root_E");
   E082 : Short_Integer; pragma Import (Ada, E082, "ada__finalization_E");
   E159 : Short_Integer; pragma Import (Ada, E159, "system__regpat_E");
   E087 : Short_Integer; pragma Import (Ada, E087, "system__storage_pools_E");
   E076 : Short_Integer; pragma Import (Ada, E076, "system__finalization_masters_E");
   E072 : Short_Integer; pragma Import (Ada, E072, "system__storage_pools__subpools_E");
   E208 : Short_Integer; pragma Import (Ada, E208, "system__task_info_E");
   E136 : Short_Integer; pragma Import (Ada, E136, "ada__calendar_E");
   E178 : Short_Integer; pragma Import (Ada, E178, "ada__calendar__time_zones_E");
   E148 : Short_Integer; pragma Import (Ada, E148, "gnat__calendar_E");
   E150 : Short_Integer; pragma Import (Ada, E150, "gnat__calendar__time_io_E");
   E123 : Short_Integer; pragma Import (Ada, E123, "gnat__directory_operations_E");
   E113 : Short_Integer; pragma Import (Ada, E113, "system__pool_global_E");
   E111 : Short_Integer; pragma Import (Ada, E111, "system__file_control_block_E");
   E165 : Short_Integer; pragma Import (Ada, E165, "ada__streams__stream_io_E");
   E101 : Short_Integer; pragma Import (Ada, E101, "system__file_io_E");
   E009 : Short_Integer; pragma Import (Ada, E009, "system__secondary_stack_E");
   E049 : Short_Integer; pragma Import (Ada, E049, "ada__strings__unbounded_E");
   E174 : Short_Integer; pragma Import (Ada, E174, "ada__directories_E");
   E131 : Short_Integer; pragma Import (Ada, E131, "system__regexp_E");
   E118 : Short_Integer; pragma Import (Ada, E118, "gnat__command_line_E");
   E163 : Short_Integer; pragma Import (Ada, E163, "system__strings__stream_ops_E");
   E230 : Short_Integer; pragma Import (Ada, E230, "system__tasking__initialization_E");
   E238 : Short_Integer; pragma Import (Ada, E238, "system__tasking__protected_objects_E");
   E096 : Short_Integer; pragma Import (Ada, E096, "ada__text_io_E");
   E242 : Short_Integer; pragma Import (Ada, E242, "system__tasking__protected_objects__entries_E");
   E236 : Short_Integer; pragma Import (Ada, E236, "system__tasking__queuing_E");
   E192 : Short_Integer; pragma Import (Ada, E192, "templates_parser_tasking_E");
   E134 : Short_Integer; pragma Import (Ada, E134, "templates_parser_E");
   E170 : Short_Integer; pragma Import (Ada, E170, "templates_parser__input_E");
   E172 : Short_Integer; pragma Import (Ada, E172, "templates_parser__utils_E");

   Local_Priority_Specific_Dispatching : constant String := "";
   Local_Interrupt_States : constant String := "";

   Is_Elaborated : Boolean := False;

   procedure finalize_library is
   begin
      declare
         procedure F1;
         pragma Import (Ada, F1, "templates_parser__finalize_body");
      begin
         E134 := E134 - 1;
         F1;
      end;
      declare
         procedure F2;
         pragma Import (Ada, F2, "templates_parser__finalize_spec");
      begin
         F2;
      end;
      declare
         procedure F3;
         pragma Import (Ada, F3, "templates_parser_tasking__finalize_body");
      begin
         E192 := E192 - 1;
         F3;
      end;
      E242 := E242 - 1;
      declare
         procedure F4;
         pragma Import (Ada, F4, "system__tasking__protected_objects__entries__finalize_spec");
      begin
         F4;
      end;
      E096 := E096 - 1;
      declare
         procedure F5;
         pragma Import (Ada, F5, "ada__text_io__finalize_spec");
      begin
         F5;
      end;
      E174 := E174 - 1;
      E131 := E131 - 1;
      declare
         procedure F6;
         pragma Import (Ada, F6, "system__regexp__finalize_spec");
      begin
         F6;
      end;
      declare
         procedure F7;
         pragma Import (Ada, F7, "ada__directories__finalize_spec");
      begin
         F7;
      end;
      E049 := E049 - 1;
      declare
         procedure F8;
         pragma Import (Ada, F8, "ada__strings__unbounded__finalize_spec");
      begin
         F8;
      end;
      E076 := E076 - 1;
      E072 := E072 - 1;
      declare
         procedure F9;
         pragma Import (Ada, F9, "system__file_io__finalize_body");
      begin
         E101 := E101 - 1;
         F9;
      end;
      E165 := E165 - 1;
      declare
         procedure F10;
         pragma Import (Ada, F10, "ada__streams__stream_io__finalize_spec");
      begin
         F10;
      end;
      declare
         procedure F11;
         pragma Import (Ada, F11, "system__file_control_block__finalize_spec");
      begin
         E111 := E111 - 1;
         F11;
      end;
      E113 := E113 - 1;
      declare
         procedure F12;
         pragma Import (Ada, F12, "system__pool_global__finalize_spec");
      begin
         F12;
      end;
      declare
         procedure F13;
         pragma Import (Ada, F13, "system__storage_pools__subpools__finalize_spec");
      begin
         F13;
      end;
      declare
         procedure F14;
         pragma Import (Ada, F14, "system__finalization_masters__finalize_spec");
      begin
         F14;
      end;
      declare
         procedure Reraise_Library_Exception_If_Any;
            pragma Import (Ada, Reraise_Library_Exception_If_Any, "__gnat_reraise_library_exception_if_any");
      begin
         Reraise_Library_Exception_If_Any;
      end;
   end finalize_library;

   procedure adafinal is
      procedure s_stalib_adafinal;
      pragma Import (C, s_stalib_adafinal, "system__standard_library__adafinal");
   begin
      if not Is_Elaborated then
         return;
      end if;
      Is_Elaborated := False;
      s_stalib_adafinal;
   end adafinal;

   type No_Param_Proc is access procedure;

   procedure adainit is
      Main_Priority : Integer;
      pragma Import (C, Main_Priority, "__gl_main_priority");
      Time_Slice_Value : Integer;
      pragma Import (C, Time_Slice_Value, "__gl_time_slice_val");
      WC_Encoding : Character;
      pragma Import (C, WC_Encoding, "__gl_wc_encoding");
      Locking_Policy : Character;
      pragma Import (C, Locking_Policy, "__gl_locking_policy");
      Queuing_Policy : Character;
      pragma Import (C, Queuing_Policy, "__gl_queuing_policy");
      Task_Dispatching_Policy : Character;
      pragma Import (C, Task_Dispatching_Policy, "__gl_task_dispatching_policy");
      Priority_Specific_Dispatching : System.Address;
      pragma Import (C, Priority_Specific_Dispatching, "__gl_priority_specific_dispatching");
      Num_Specific_Dispatching : Integer;
      pragma Import (C, Num_Specific_Dispatching, "__gl_num_specific_dispatching");
      Main_CPU : Integer;
      pragma Import (C, Main_CPU, "__gl_main_cpu");
      Interrupt_States : System.Address;
      pragma Import (C, Interrupt_States, "__gl_interrupt_states");
      Num_Interrupt_States : Integer;
      pragma Import (C, Num_Interrupt_States, "__gl_num_interrupt_states");
      Unreserve_All_Interrupts : Integer;
      pragma Import (C, Unreserve_All_Interrupts, "__gl_unreserve_all_interrupts");
      Exception_Tracebacks : Integer;
      pragma Import (C, Exception_Tracebacks, "__gl_exception_tracebacks");
      Detect_Blocking : Integer;
      pragma Import (C, Detect_Blocking, "__gl_detect_blocking");
      Default_Stack_Size : Integer;
      pragma Import (C, Default_Stack_Size, "__gl_default_stack_size");
      Leap_Seconds_Support : Integer;
      pragma Import (C, Leap_Seconds_Support, "__gl_leap_seconds_support");

      procedure Install_Handler;
      pragma Import (C, Install_Handler, "__gnat_install_handler");

      Handler_Installed : Integer;
      pragma Import (C, Handler_Installed, "__gnat_handler_installed");

      Finalize_Library_Objects : No_Param_Proc;
      pragma Import (C, Finalize_Library_Objects, "__gnat_finalize_library_objects");
   begin
      if Is_Elaborated then
         return;
      end if;
      Is_Elaborated := True;
      Main_Priority := -1;
      Time_Slice_Value := -1;
      WC_Encoding := 'b';
      Locking_Policy := ' ';
      Queuing_Policy := ' ';
      Task_Dispatching_Policy := ' ';
      System.Restrictions.Run_Time_Restrictions :=
        (Set =>
          (False, False, False, False, False, False, False, False, 
           False, False, False, False, False, False, False, False, 
           False, False, False, False, False, False, False, False, 
           False, False, False, False, False, False, False, False, 
           False, False, False, False, False, False, False, False, 
           False, False, False, False, False, False, False, False, 
           False, False, False, False, False, False, False, False, 
           False, False, False, False, False, False, False, False, 
           False, False, False, True, False, False, False, False, 
           False, False, False, False, False, False),
         Value => (0, 0, 0, 0, 0, 0, 0),
         Violated =>
          (True, False, True, True, False, False, False, True, 
           False, True, True, True, True, False, False, True, 
           False, False, True, True, False, True, True, True, 
           True, True, True, True, True, True, False, True, 
           False, False, True, False, True, True, False, False, 
           True, True, False, False, True, False, True, False, 
           False, False, False, False, False, True, True, True, 
           False, False, True, False, False, True, False, True, 
           True, False, True, True, True, False, True, True, 
           False, False, False, False, True, False),
         Count => (2, 0, 0, 0, 0, 1, 0),
         Unknown => (False, False, False, False, False, True, False));
      Priority_Specific_Dispatching :=
        Local_Priority_Specific_Dispatching'Address;
      Num_Specific_Dispatching := 0;
      Main_CPU := -1;
      Interrupt_States := Local_Interrupt_States'Address;
      Num_Interrupt_States := 0;
      Unreserve_All_Interrupts := 0;
      Exception_Tracebacks := 1;
      Detect_Blocking := 0;
      Default_Stack_Size := -1;
      Leap_Seconds_Support := 0;

      if Handler_Installed = 0 then
         Install_Handler;
      end if;

      Finalize_Library_Objects := finalize_library'access;

      System.Soft_Links'Elab_Spec;
      System.Exception_Table'Elab_Body;
      E019 := E019 + 1;
      Ada.Containers'Elab_Spec;
      E139 := E139 + 1;
      Ada.Io_Exceptions'Elab_Spec;
      E094 := E094 + 1;
      Ada.Strings'Elab_Spec;
      E047 := E047 + 1;
      Ada.Strings.Maps'Elab_Spec;
      Ada.Strings.Maps.Constants'Elab_Spec;
      E121 := E121 + 1;
      Ada.Tags'Elab_Spec;
      Ada.Streams'Elab_Spec;
      E083 := E083 + 1;
      Interfaces.C'Elab_Spec;
      Interfaces.C.Strings'Elab_Spec;
      System.Exceptions'Elab_Spec;
      E025 := E025 + 1;
      System.Finalization_Root'Elab_Spec;
      E085 := E085 + 1;
      Ada.Finalization'Elab_Spec;
      E082 := E082 + 1;
      System.Regpat'Elab_Spec;
      System.Storage_Pools'Elab_Spec;
      E087 := E087 + 1;
      System.Finalization_Masters'Elab_Spec;
      System.Storage_Pools.Subpools'Elab_Spec;
      System.Task_Info'Elab_Spec;
      E208 := E208 + 1;
      Ada.Calendar'Elab_Spec;
      Ada.Calendar'Elab_Body;
      E136 := E136 + 1;
      Ada.Calendar.Time_Zones'Elab_Spec;
      E178 := E178 + 1;
      Gnat.Calendar'Elab_Spec;
      E148 := E148 + 1;
      Gnat.Calendar.Time_Io'Elab_Spec;
      Gnat.Directory_Operations'Elab_Spec;
      System.Pool_Global'Elab_Spec;
      E113 := E113 + 1;
      System.File_Control_Block'Elab_Spec;
      E111 := E111 + 1;
      Ada.Streams.Stream_Io'Elab_Spec;
      E165 := E165 + 1;
      System.File_Io'Elab_Body;
      E101 := E101 + 1;
      E072 := E072 + 1;
      System.Finalization_Masters'Elab_Body;
      E076 := E076 + 1;
      E159 := E159 + 1;
      E105 := E105 + 1;
      E103 := E103 + 1;
      Ada.Tags'Elab_Body;
      E060 := E060 + 1;
      E053 := E053 + 1;
      System.Soft_Links'Elab_Body;
      E013 := E013 + 1;
      System.Os_Lib'Elab_Body;
      E108 := E108 + 1;
      System.Secondary_Stack'Elab_Body;
      E009 := E009 + 1;
      Gnat.Directory_Operations'Elab_Body;
      E123 := E123 + 1;
      Ada.Strings.Unbounded'Elab_Spec;
      E049 := E049 + 1;
      Ada.Directories'Elab_Spec;
      System.Regexp'Elab_Spec;
      E131 := E131 + 1;
      Ada.Directories'Elab_Body;
      E174 := E174 + 1;
      Gnat.Command_Line'Elab_Spec;
      System.Strings.Stream_Ops'Elab_Body;
      E163 := E163 + 1;
      System.Tasking.Initialization'Elab_Body;
      E230 := E230 + 1;
      System.Tasking.Protected_Objects'Elab_Body;
      E238 := E238 + 1;
      Ada.Text_Io'Elab_Spec;
      Ada.Text_Io'Elab_Body;
      E096 := E096 + 1;
      Gnat.Command_Line'Elab_Body;
      E118 := E118 + 1;
      E150 := E150 + 1;
      System.Tasking.Protected_Objects.Entries'Elab_Spec;
      E242 := E242 + 1;
      System.Tasking.Queuing'Elab_Body;
      E236 := E236 + 1;
      Templates_Parser_Tasking'Elab_Body;
      E192 := E192 + 1;
      Templates_Parser'Elab_Spec;
      Templates_Parser.Input'Elab_Spec;
      E170 := E170 + 1;
      Templates_Parser.Utils'Elab_Spec;
      E172 := E172 + 1;
      Templates_Parser'Elab_Body;
      E134 := E134 + 1;
   end adainit;

   procedure Ada_Main_Program;
   pragma Import (Ada, Ada_Main_Program, "_ada_templatespp");

   function main
     (argc : Integer;
      argv : System.Address;
      envp : System.Address)
      return Integer
   is
      procedure Initialize (Addr : System.Address);
      pragma Import (C, Initialize, "__gnat_initialize");

      procedure Finalize;
      pragma Import (C, Finalize, "__gnat_finalize");
      SEH : aliased array (1 .. 2) of Integer;

      Ensure_Reference : aliased System.Address := Ada_Main_Program_Name'Address;
      pragma Volatile (Ensure_Reference);

   begin
      gnat_argc := argc;
      gnat_argv := argv;
      gnat_envp := envp;

      Initialize (SEH'Address);
      adainit;
      Ada_Main_Program;
      adafinal;
      Finalize;
      return (gnat_exit_status);
   end;

--  BEGIN Object file/option list
   --   /builddir/build/BUILD/templates_parser-11.6.0/.build/native/release/relocatable/tobj/templatespp.o
   --   -L/builddir/build/BUILD/templates_parser-11.6.0/.build/native/release/relocatable/tobj/
   --   -L/builddir/build/BUILD/templates_parser-11.6.0/.build/native/release/relocatable/tobj/
   --   -L/builddir/build/BUILD/templates_parser-11.6.0/.build/native/release/relocatable/lib/
   --   -L/usr/lib/xmlada/relocatable/
   --   -L/usr/lib/gcc/ppc64-redhat-linux/4.8.0/adalib/
   --   -shared
   --   -lgnarl-4.8
   --   -lgnat-4.8
   --   -lpthread
--  END Object file/option list   

end ada_main;
